
   import external.Viewer;
   import external.viewer.*;
   import java.awt.Color;
   import javax.swing.JComponent;
   import flgl.*;
   import flgl.graph.*;
   import flgl.algorithm.*;

    public class java__util__TreeMap_View extends ScrolledLayoutCanvas
         implements external.Viewer {
      private Layout layout_ = new Layout();
   
       public java__util__TreeMap_View() {
         super(0, 0, false);
         setBackground(Color.white);
         layout_.addView(this);
         layout_.setButtonActions(new int[] {
               layout_.ACTION_SELECT_ANY, layout_.ACTION_NONE, layout_.ACTION_NONE,
               layout_.ACTION_CREATE_BEND, layout_.ACTION_NONE, layout_.ACTION_NONE,
               layout_.ACTION_SELECT_TOGGLE, layout_.ACTION_NONE, layout_.ACTION_NONE,
               });
         layout_.disallowNodeActions(Node.EDIT_LABEL | Node.RESIZE |
            Node.DELETE);
         layout_.disallowEdgeActions(Edge.DELETE | Edge.MOVE_HEAD |
            Edge.MOVE_TAIL);
         layout_.setShowAxes(null, false);
      }
       
       public JComponent getComponent() {
         return this; }
          
       public String getName() {
         return "Red Black Tree"; }
   
       public int getPriority() {
         return 20; }
   
       public void setFrozen() {}
   
       public void update(Value value, DebugContext context) throws ViewerException {
         Value root = value.getFieldValue(context, "root");
         layout_.removeAll();
         Node root_node = descendTree_(context, root, null, 0.0);
         TreeAlgorithm alg = new TreeAlgorithm('d');
         alg.setRoot(root_node);
         alg.setBendEdges(false);
         layout_.hSpacing = 20;
         layout_.vSpacing = 20;
         layout_.applyAlgorithm(alg);
      }
      
      
       private Node descendTree_(DebugContext context, Value node, Node parent, double x_pos)
            throws ViewerException {
         if(node == null)
            return null;
         Value key_val = node.getFieldValue(context, "key");
         Value value_val = node.getFieldValue(context, "value");
         Value color_val = node.getFieldValue(context, "color");
         Value left_val = node.getFieldValue(context, "left");
         Value right_val = node.getFieldValue(context, "right");
         
         MutableShapeNode graph_node = new MutableShapeNode();
         
         String key_str = key_val.toString(context);
         if(key_str.length() > 25)
            key_str = key_str.substring(0, 21) + " ...";
      
         String value_str = value_val.toString(context);
         if(value_str.length() > 25)
            value_str = value_str.substring(0, 21) + " ...";
         
         graph_node.setLabel(key_str + ": " + value_str);
         graph_node.setLabelPosition(Node.IN);
         graph_node.setBackground(color_val.toBoolean(context)?Color.black:Color.red);
         graph_node.setPosition(x_pos, 0.0);
         layout_.addNode(graph_node);
         
         if(parent != null)
            layout_.addEdge(new Edge(parent, graph_node, Edge.NONE, Edge.ARROW));
         
         descendTree_(context, left_val, graph_node, x_pos - 10.0);
         descendTree_(context, right_val, graph_node, x_pos + 10.0);
         
         return graph_node;
      }
   }
